Index: uspace/srv/fs/locfs/locfs_ops.c
===================================================================
--- uspace/srv/fs/locfs/locfs_ops.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/locfs/locfs_ops.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -101,5 +101,5 @@
 };
 
-static errno_t locfs_node_get_internal(fs_node_t **rfn, loc_object_type_t type,
+static int locfs_node_get_internal(fs_node_t **rfn, loc_object_type_t type,
     service_id_t service_id)
 {
@@ -125,13 +125,13 @@
 }
 
-static errno_t locfs_root_get(fs_node_t **rfn, service_id_t service_id)
+static int locfs_root_get(fs_node_t **rfn, service_id_t service_id)
 {
 	return locfs_node_get_internal(rfn, LOC_OBJECT_NONE, 0);
 }
 
-static errno_t locfs_match(fs_node_t **rfn, fs_node_t *pfn, const char *component)
+static int locfs_match(fs_node_t **rfn, fs_node_t *pfn, const char *component)
 {
 	locfs_node_t *node = (locfs_node_t *) pfn->data;
-	errno_t ret;
+	int ret;
 	
 	if (node->service_id == 0) {
@@ -208,10 +208,10 @@
 }
 
-static errno_t locfs_node_get(fs_node_t **rfn, service_id_t service_id, fs_index_t index)
+static int locfs_node_get(fs_node_t **rfn, service_id_t service_id, fs_index_t index)
 {
 	return locfs_node_get_internal(rfn, loc_id_probe(index), index);
 }
 
-static errno_t locfs_node_open(fs_node_t *fn)
+static int locfs_node_open(fs_node_t *fn)
 {
 	locfs_node_t *node = (locfs_node_t *) fn->data;
@@ -312,5 +312,5 @@
 }
 
-static errno_t locfs_node_put(fs_node_t *fn)
+static int locfs_node_put(fs_node_t *fn)
 {
 	free(fn->data);
@@ -319,5 +319,5 @@
 }
 
-static errno_t locfs_create_node(fs_node_t **rfn, service_id_t service_id, int lflag)
+static int locfs_create_node(fs_node_t **rfn, service_id_t service_id, int lflag)
 {
 	assert((lflag & L_FILE) ^ (lflag & L_DIRECTORY));
@@ -327,20 +327,20 @@
 }
 
-static errno_t locfs_destroy_node(fs_node_t *fn)
+static int locfs_destroy_node(fs_node_t *fn)
 {
 	return ENOTSUP;
 }
 
-static errno_t locfs_link_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
+static int locfs_link_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
 {
 	return ENOTSUP;
 }
 
-static errno_t locfs_unlink_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
+static int locfs_unlink_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
 {
 	return ENOTSUP;
 }
 
-static errno_t locfs_has_children(bool *has_children, fs_node_t *fn)
+static int locfs_has_children(bool *has_children, fs_node_t *fn)
 {
 	locfs_node_t *node = (locfs_node_t *) fn->data;
@@ -455,10 +455,10 @@
 }
 
-static errno_t locfs_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
+static int locfs_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
 {
 	return ENOTSUP;
 }
 
-static errno_t locfs_mounted(service_id_t service_id, const char *opts,
+static int locfs_mounted(service_id_t service_id, const char *opts,
     fs_index_t *index, aoff64_t *size)
 {
@@ -468,10 +468,10 @@
 }
 
-static errno_t locfs_unmounted(service_id_t service_id)
+static int locfs_unmounted(service_id_t service_id)
 {
 	return ENOTSUP;
 }
 
-static errno_t
+static int
 locfs_read(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *rbytes)
@@ -590,9 +590,9 @@
 		
 		/* Wait for reply from the driver. */
-		errno_t rc;
+		sysarg_t rc;
 		async_wait_for(msg, &rc);
 
 		/* Do not propagate EHANGUP back to VFS. */
-		if ((errno_t) rc == EHANGUP)
+		if ((int) rc == EHANGUP)
 			rc = ENOTSUP;
 		
@@ -604,5 +604,5 @@
 }
 
-static errno_t
+static int
 locfs_write(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *wbytes, aoff64_t *nsize)
@@ -654,9 +654,9 @@
 		
 		/* Wait for reply from the driver. */
-		errno_t rc;
+		sysarg_t rc;
 		async_wait_for(msg, &rc);
 
 		/* Do not propagate EHANGUP back to VFS. */
-		if ((errno_t) rc == EHANGUP)
+		if ((int) rc == EHANGUP)
 			rc = ENOTSUP;
 		
@@ -669,5 +669,5 @@
 }
 
-static errno_t
+static int
 locfs_truncate(service_id_t service_id, fs_index_t index, aoff64_t size)
 {
@@ -675,5 +675,5 @@
 }
 
-static errno_t locfs_close(service_id_t service_id, fs_index_t index)
+static int locfs_close(service_id_t service_id, fs_index_t index)
 {
 	if (index == 0)
@@ -715,5 +715,5 @@
 }
 
-static errno_t locfs_sync(service_id_t service_id, fs_index_t index)
+static int locfs_sync(service_id_t service_id, fs_index_t index)
 {
 	if (index == 0)
@@ -752,5 +752,5 @@
 		
 		/* Wait for reply from the driver */
-		errno_t rc;
+		sysarg_t rc;
 		async_wait_for(msg, &rc);
 		
@@ -761,5 +761,5 @@
 }
 
-static errno_t locfs_destroy(service_id_t service_id, fs_index_t index)
+static int locfs_destroy(service_id_t service_id, fs_index_t index)
 {
 	return ENOTSUP;
Index: uspace/srv/fs/mfs/mfs.c
===================================================================
--- uspace/srv/fs/mfs/mfs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/mfs/mfs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,5 +44,4 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <task.h>
 #include <stdio.h>
@@ -59,5 +58,5 @@
 int main(int argc, char **argv)
 {
-	errno_t rc;
+	int rc;
 
 	printf(NAME ": HelenOS Minix file system server\n");
@@ -68,5 +67,5 @@
 		else {
 			printf(NAME " Unrecognized parameters");
-			rc = EINVAL;
+			rc = -1;
 			goto err;
 		}
@@ -78,6 +77,5 @@
 	if (!vfs_sess) {
 		printf(NAME ": failed to connect to VFS\n");
-		rc = errno;
-		goto err;
+		return -1;
 	}
 
@@ -99,5 +97,5 @@
 
 err:
-	printf(NAME ": Failed to register file system: %s\n", str_error(rc));
+	printf(NAME ": Failed to register file system (%d)\n", rc);
 	return rc;
 }
Index: uspace/srv/fs/mfs/mfs.h
===================================================================
--- uspace/srv/fs/mfs/mfs.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/mfs/mfs.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -169,60 +169,60 @@
 extern libfs_ops_t mfs_libfs_ops;
 
-extern errno_t
+extern int
 mfs_global_init(void);
 
 /* mfs_inode.c */
-extern errno_t
+extern int
 mfs_get_inode(struct mfs_instance *inst, struct mfs_ino_info **ino_i,
     fs_index_t index);
 
-extern errno_t
+extern int
 mfs_put_inode(struct mfs_node *mnode);
 
-extern errno_t
+extern int
 mfs_inode_shrink(struct mfs_node *mnode, size_t size_shrink);
 
 /* mfs_rw.c */
-extern errno_t
+extern int
 mfs_read_map(uint32_t *b, const struct mfs_node *mnode, const uint32_t pos);
 
-extern errno_t
+extern int
 mfs_write_map(struct mfs_node *mnode, uint32_t pos, uint32_t new_zone,
     uint32_t *old_zone);
 
-extern errno_t
+extern int
 mfs_prune_ind_zones(struct mfs_node *mnode, size_t new_size);
 
 /* mfs_dentry.c */
-extern errno_t
+extern int
 mfs_read_dentry(struct mfs_node *mnode,
     struct mfs_dentry_info *d_info, unsigned index);
 
-extern errno_t
+extern int
 mfs_write_dentry(struct mfs_dentry_info *d_info);
 
-extern errno_t
+extern int
 mfs_remove_dentry(struct mfs_node *mnode, const char *d_name);
 
-extern errno_t
+extern int
 mfs_insert_dentry(struct mfs_node *mnode, const char *d_name, fs_index_t d_inum);
 
 /* mfs_balloc.c */
-extern errno_t
+extern int
 mfs_alloc_inode(struct mfs_instance *inst, uint32_t *inum);
 
-extern errno_t
+extern int
 mfs_free_inode(struct mfs_instance *inst, uint32_t inum);
 
-extern errno_t
+extern int
 mfs_alloc_zone(struct mfs_instance *inst, uint32_t *zone);
 
-extern errno_t
+extern int
 mfs_free_zone(struct mfs_instance *inst, uint32_t zone);
 
-extern errno_t
+extern int
 mfs_count_free_zones(struct mfs_instance *inst, uint32_t *zones);
 
-extern errno_t
+extern int
 mfs_count_free_inodes(struct mfs_instance *inst, uint32_t *inodes);
 
Index: uspace/srv/fs/mfs/mfs_balloc.c
===================================================================
--- uspace/srv/fs/mfs/mfs_balloc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/mfs/mfs_balloc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,11 +38,11 @@
     const bool native, unsigned start_bit);
 
-static errno_t
+static int
 mfs_free_bit(struct mfs_instance *inst, uint32_t idx, bmap_id_t bid);
 
-static errno_t
+static int
 mfs_alloc_bit(struct mfs_instance *inst, uint32_t *idx, bmap_id_t bid);
 
-static errno_t
+static int
 mfs_count_free_bits(struct mfs_instance *inst, bmap_id_t bid, uint32_t *free);
 
@@ -54,10 +54,10 @@
  * 			the new inode will be saved.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_alloc_inode(struct mfs_instance *inst, uint32_t *inum)
 {
-	errno_t r = mfs_alloc_bit(inst, inum, BMAP_INODE);
+	int r = mfs_alloc_bit(inst, inum, BMAP_INODE);
 	return r;
 }
@@ -68,7 +68,7 @@
  * @param inum		Number of the inode to free.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_free_inode(struct mfs_instance *inst, uint32_t inum)
 {
@@ -82,10 +82,10 @@
  * 			of the zone will be saved.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_alloc_zone(struct mfs_instance *inst, uint32_t *zone)
 {
-	errno_t r = mfs_alloc_bit(inst, zone, BMAP_ZONE);
+	int r = mfs_alloc_bit(inst, zone, BMAP_ZONE);
 	if (r != EOK)
 		return r;
@@ -105,10 +105,10 @@
  * @param zone		Index of the zone to free.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_free_zone(struct mfs_instance *inst, uint32_t zone)
 {
-	errno_t r;
+	int r;
 
 	zone -= inst->sbi->firstdatazone - 1;
@@ -132,7 +132,7 @@
  *                      will be stored.
  *
- * @return              EOK on success or an error code.
- */
-errno_t
+ * @return              EOK on success or a negative error code.
+ */
+int
 mfs_count_free_zones(struct mfs_instance *inst, uint32_t *zones)
 {
@@ -146,8 +146,8 @@
  *                      will be stored.
  *
- * @return              EOK on success or an error code.
- */
-
-errno_t
+ * @return              EOK on success or a negative error code.
+ */
+
+int
 mfs_count_free_inodes(struct mfs_instance *inst, uint32_t *inodes)
 {
@@ -162,10 +162,10 @@
  *                      will be stores.
  *
- * @return              EOK on success or an error code.
- */
-static errno_t
+ * @return              EOK on success or a negative error code.
+ */
+static int
 mfs_count_free_bits(struct mfs_instance *inst, bmap_id_t bid, uint32_t *free)
 {
-	errno_t r;
+	int r;
 	unsigned start_block;
 	unsigned long nblocks;
@@ -226,11 +226,11 @@
  * 			BMAP_INODE if operating on the inode's bitmap.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t
+ * @return		EOK on success or a negative error code.
+ */
+static int
 mfs_free_bit(struct mfs_instance *inst, uint32_t idx, bmap_id_t bid)
 {
 	struct mfs_sb_info *sbi;
-	errno_t r;
+	int r;
 	unsigned start_block;
 	unsigned *search;
@@ -246,5 +246,5 @@
 			printf(NAME ": Error! Trying to free beyond the "
 			    "bitmap max size\n");
-			return EIO;
+			return -1;
 		}
 	} else {
@@ -254,5 +254,5 @@
 			printf(NAME ": Error! Trying to free beyond the "
 			    "bitmap max size\n");
-			return EIO;
+			return -1;
 		}
 	}
@@ -293,7 +293,7 @@
  * 			BMAP_INODE if operating on the inode's bitmap.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t
+ * @return		EOK on success or a negative error code.
+ */
+static int
 mfs_alloc_bit(struct mfs_instance *inst, uint32_t *idx, bmap_id_t bid)
 {
@@ -303,6 +303,5 @@
 	unsigned *search, i, start_block;
 	unsigned bits_per_block;
-	errno_t r;
-	int freebit;
+	int r, freebit;
 
 	sbi = inst->sbi;
Index: uspace/srv/fs/mfs/mfs_dentry.c
===================================================================
--- uspace/srv/fs/mfs/mfs_dentry.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/mfs/mfs_dentry.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -31,5 +31,4 @@
  */
 
-#include <str.h>
 #include "mfs.h"
 
@@ -41,7 +40,7 @@
  * @param index		index of the dentry in the list.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_read_dentry(struct mfs_node *mnode,
     struct mfs_dentry_info *d_info, unsigned index)
@@ -53,5 +52,5 @@
 	block_t *b;
 
-	errno_t r = mfs_read_map(&block, mnode, index * sbi->dirsize);
+	int r = mfs_read_map(&block, mnode, index * sbi->dirsize);
 	if (r != EOK)
 		goto out_err;
@@ -104,7 +103,7 @@
  * @param d_info The directory entry to write to disk.
  *
- * @return	 EOK on success or an error code.
- */
-errno_t
+ * @return	 EOK on success or a negative error code.
+ */
+int
 mfs_write_dentry(struct mfs_dentry_info *d_info)
 {
@@ -115,5 +114,5 @@
 	block_t *b;
 	uint32_t block;
-	errno_t r;
+	int r;
 
 	r = mfs_read_map(&block, mnode, d_off_bytes);
@@ -155,12 +154,12 @@
  * @param d_name	Name of the directory entry to delete.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_remove_dentry(struct mfs_node *mnode, const char *d_name)
 {
 	struct mfs_sb_info *sbi = mnode->instance->sbi;
 	struct mfs_dentry_info d_info;
-	errno_t r;
+	int r;
 
 	const size_t name_len = str_size(d_name);
@@ -196,11 +195,11 @@
  * @param d_inum	index of the inode that will be pointed by the new dentry.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_insert_dentry(struct mfs_node *mnode, const char *d_name,
     fs_index_t d_inum)
 {
-	errno_t r;
+	int r;
 	struct mfs_sb_info *sbi = mnode->instance->sbi;
 	struct mfs_dentry_info d_info;
Index: uspace/srv/fs/mfs/mfs_inode.c
===================================================================
--- uspace/srv/fs/mfs/mfs_inode.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/mfs/mfs_inode.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,15 +34,15 @@
 #include "mfs.h"
 
-static errno_t
+static int
 mfs_write_inode_raw(struct mfs_node *mnode);
 
-static errno_t
+static int
 mfs2_write_inode_raw(struct mfs_node *mnode);
 
-static errno_t
+static int
 mfs_read_inode_raw(const struct mfs_instance *instance,
     struct mfs_ino_info **ino_ptr, uint16_t inum);
 
-static errno_t
+static int
 mfs2_read_inode_raw(const struct mfs_instance *instance,
     struct mfs_ino_info **ino_ptr, uint32_t inum);
@@ -55,12 +55,12 @@
  * @param index		index of the inode to read.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_get_inode(struct mfs_instance *inst, struct mfs_ino_info **ino_i,
     fs_index_t index)
 {
 	struct mfs_sb_info *sbi = inst->sbi;
-	errno_t r;
+	int r;
 
 	if (sbi->fs_version == MFS_VERSION_V1) {
@@ -75,5 +75,5 @@
 }
 
-static errno_t
+static int
 mfs_read_inode_raw(const struct mfs_instance *instance,
     struct mfs_ino_info **ino_ptr, uint16_t inum)
@@ -83,6 +83,5 @@
 	struct mfs_sb_info *sbi;
 	block_t *b;
-	int i;
-	errno_t r;
+	int i, r;
 
 	sbi = instance->sbi;
@@ -135,5 +134,5 @@
 }
 
-static errno_t
+static int
 mfs2_read_inode_raw(const struct mfs_instance *instance,
     struct mfs_ino_info **ino_ptr, uint32_t inum)
@@ -143,6 +142,5 @@
 	struct mfs_sb_info *sbi;
 	block_t *b;
-	int i;
-	errno_t r;
+	int i, r;
 
 	ino_i = malloc(sizeof(*ino_i));
@@ -201,10 +199,10 @@
  * @param mnode		Pointer to the generic MINIX inode in memory.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_put_inode(struct mfs_node *mnode)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	if (!mnode->ino_i->dirty)
@@ -223,9 +221,8 @@
 }
 
-static errno_t
+static int
 mfs_write_inode_raw(struct mfs_node *mnode)
 {
-	int i;
-	errno_t r;
+	int i, r;
 	block_t *b;
 	struct mfs_ino_info *ino_i = mnode->ino_i;
@@ -267,5 +264,5 @@
 }
 
-static errno_t
+static int
 mfs2_write_inode_raw(struct mfs_node *mnode)
 {
@@ -273,6 +270,5 @@
 	struct mfs_sb_info *sbi = mnode->instance->sbi;
 	block_t *b;
-	int i;
-	errno_t r;
+	int i, r;
 
 	const uint32_t inum = ino_i->index - 1;
@@ -319,7 +315,7 @@
  * @param size_shrink	Number of bytes that will be subtracted to the inode.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 mfs_inode_shrink(struct mfs_node *mnode, size_t size_shrink)
 {
@@ -327,5 +323,5 @@
 	struct mfs_ino_info *ino_i = mnode->ino_i;
 	const size_t bs = sbi->block_size;
-	errno_t r;
+	int r;
 
 	if (size_shrink == 0) {
Index: uspace/srv/fs/mfs/mfs_ops.c
===================================================================
--- uspace/srv/fs/mfs/mfs_ops.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/mfs/mfs_ops.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <adt/hash_table.h>
 #include <adt/hash.h>
-#include <str.h>
 #include "mfs.h"
 
@@ -42,30 +41,30 @@
 static bool check_magic_number(uint16_t magic, bool *native,
     mfs_version_t *version, bool *longfilenames);
-static errno_t mfs_node_core_get(fs_node_t **rfn, struct mfs_instance *inst,
+static int mfs_node_core_get(fs_node_t **rfn, struct mfs_instance *inst,
     fs_index_t index);
-static errno_t mfs_node_put(fs_node_t *fsnode);
-static errno_t mfs_node_open(fs_node_t *fsnode);
+static int mfs_node_put(fs_node_t *fsnode);
+static int mfs_node_open(fs_node_t *fsnode);
 static fs_index_t mfs_index_get(fs_node_t *fsnode);
 static unsigned mfs_lnkcnt_get(fs_node_t *fsnode);
 static bool mfs_is_directory(fs_node_t *fsnode);
 static bool mfs_is_file(fs_node_t *fsnode);
-static errno_t mfs_has_children(bool *has_children, fs_node_t *fsnode);
-static errno_t mfs_root_get(fs_node_t **rfn, service_id_t service_id);
+static int mfs_has_children(bool *has_children, fs_node_t *fsnode);
+static int mfs_root_get(fs_node_t **rfn, service_id_t service_id);
 static service_id_t mfs_service_get(fs_node_t *fsnode);
 static aoff64_t mfs_size_get(fs_node_t *node);
-static errno_t mfs_match(fs_node_t **rfn, fs_node_t *pfn, const char *component);
-static errno_t mfs_create_node(fs_node_t **rfn, service_id_t service_id, int flags);
-static errno_t mfs_link(fs_node_t *pfn, fs_node_t *cfn, const char *name);
-static errno_t mfs_unlink(fs_node_t *, fs_node_t *, const char *name);
-static errno_t mfs_destroy_node(fs_node_t *fn);
-static errno_t mfs_node_get(fs_node_t **rfn, service_id_t service_id,
+static int mfs_match(fs_node_t **rfn, fs_node_t *pfn, const char *component);
+static int mfs_create_node(fs_node_t **rfn, service_id_t service_id, int flags);
+static int mfs_link(fs_node_t *pfn, fs_node_t *cfn, const char *name);
+static int mfs_unlink(fs_node_t *, fs_node_t *, const char *name);
+static int mfs_destroy_node(fs_node_t *fn);
+static int mfs_node_get(fs_node_t **rfn, service_id_t service_id,
     fs_index_t index);
-static errno_t mfs_instance_get(service_id_t service_id,
+static int mfs_instance_get(service_id_t service_id,
     struct mfs_instance **instance);
-static errno_t mfs_check_sanity(struct mfs_sb_info *sbi);
+static int mfs_check_sanity(struct mfs_sb_info *sbi);
 static bool is_power_of_two(uint32_t n);
-static errno_t mfs_size_block(service_id_t service_id, uint32_t *size);
-static errno_t mfs_total_block_count(service_id_t service_id, uint64_t *count);
-static errno_t mfs_free_block_count(service_id_t service_id, uint64_t *count);
+static int mfs_size_block(service_id_t service_id, uint32_t *size);
+static int mfs_total_block_count(service_id_t service_id, uint64_t *count);
+static int mfs_free_block_count(service_id_t service_id, uint64_t *count);
 
 static hash_table_t open_nodes;
@@ -132,5 +131,5 @@
 };
 
-errno_t
+int
 mfs_global_init(void)
 {
@@ -143,5 +142,5 @@
 /** Read the superblock.
  */
-static errno_t mfs_read_sb(service_id_t service_id, struct mfs_sb_info **rsbi)
+static int mfs_read_sb(service_id_t service_id, struct mfs_sb_info **rsbi)
 {
 	struct mfs_superblock *sb = NULL;
@@ -152,5 +151,5 @@
 	mfs_version_t version;
 	uint16_t magic;
-	errno_t rc;
+	int rc;
 
 	/* Allocate space for generic MFS superblock */
@@ -278,8 +277,8 @@
 
 
-static errno_t mfs_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
+static int mfs_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
 {
 	struct mfs_sb_info *sbi = NULL;
-	errno_t rc;
+	int rc;
 
 	/* Initialize libblock */
@@ -295,5 +294,5 @@
 }
 
-static errno_t
+static int
 mfs_mounted(service_id_t service_id, const char *opts, fs_index_t *index,
     aoff64_t *size)
@@ -302,5 +301,5 @@
 	struct mfs_sb_info *sbi = NULL;
 	struct mfs_instance *instance = NULL;
-	errno_t rc;
+	int rc;
 
 	/* Check for option enabling write through. */
@@ -366,5 +365,5 @@
 }
 
-static errno_t
+static int
 mfs_unmounted(service_id_t service_id)
 {
@@ -373,5 +372,5 @@
 	mfsdebug("%s()\n", __FUNCTION__);
 
-	errno_t r = mfs_instance_get(service_id, &inst);
+	int r = mfs_instance_get(service_id, &inst);
 	if (r != EOK)
 		return r;
@@ -397,8 +396,8 @@
 }
 
-static errno_t
+static int
 mfs_create_node(fs_node_t **rfn, service_id_t service_id, int flags)
 {
-	errno_t r;
+	int r;
 	struct mfs_instance *inst;
 	struct mfs_node *mnode;
@@ -484,5 +483,5 @@
 }
 
-static errno_t
+static int
 mfs_match(fs_node_t **rfn, fs_node_t *pfn, const char *component)
 {
@@ -490,5 +489,5 @@
 	struct mfs_ino_info *ino_i = mnode->ino_i;
 	struct mfs_dentry_info d_info;
-	errno_t r;
+	int r;
 
 	if (!S_ISDIR(ino_i->i_mode))
@@ -531,9 +530,9 @@
 }
 
-static errno_t
+static int
 mfs_node_get(fs_node_t **rfn, service_id_t service_id,
     fs_index_t index)
 {
-	errno_t rc;
+	int rc;
 	struct mfs_instance *instance;
 
@@ -545,8 +544,8 @@
 }
 
-static errno_t
+static int
 mfs_node_put(fs_node_t *fsnode)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 	struct mfs_node *mnode = fsnode->data;
 
@@ -569,5 +568,5 @@
 }
 
-static errno_t
+static int
 mfs_node_open(fs_node_t *fsnode)
 {
@@ -602,5 +601,5 @@
 }
 
-static errno_t
+static int
 mfs_node_core_get(fs_node_t **rfn, struct mfs_instance *inst,
     fs_index_t index)
@@ -608,5 +607,5 @@
 	fs_node_t *node = NULL;
 	struct mfs_node *mnode = NULL;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&open_nodes_lock);
@@ -689,12 +688,12 @@
 }
 
-static errno_t
+static int
 mfs_root_get(fs_node_t **rfn, service_id_t service_id)
 {
-	errno_t rc = mfs_node_get(rfn, service_id, MFS_ROOT_INO);
+	int rc = mfs_node_get(rfn, service_id, MFS_ROOT_INO);
 	return rc;
 }
 
-static errno_t
+static int
 mfs_link(fs_node_t *pfn, fs_node_t *cfn, const char *name)
 {
@@ -707,5 +706,5 @@
 		return ENAMETOOLONG;
 
-	errno_t r = mfs_insert_dentry(parent, name, child->ino_i->index);
+	int r = mfs_insert_dentry(parent, name, child->ino_i->index);
 	if (r != EOK)
 		return r;
@@ -737,5 +736,5 @@
 exit:
 	if (destroy_dentry) {
-		errno_t r2 = mfs_remove_dentry(parent, name);
+		int r2 = mfs_remove_dentry(parent, name);
 		if (r2 != EOK)
 			r = r2;
@@ -747,5 +746,5 @@
 }
 
-static errno_t
+static int
 mfs_unlink(fs_node_t *pfn, fs_node_t *cfn, const char *name)
 {
@@ -753,5 +752,5 @@
 	struct mfs_node *child = cfn->data;
 	bool has_children;
-	errno_t r;
+	int r;
 
 	if (!parent)
@@ -788,10 +787,10 @@
 }
 
-static errno_t
+static int
 mfs_has_children(bool *has_children, fs_node_t *fsnode)
 {
 	struct mfs_node *mnode = fsnode->data;
 	struct mfs_sb_info *sbi = mnode->instance->sbi;
-	errno_t r;
+	int r;
 
 	*has_children = false;
@@ -820,9 +819,9 @@
 }
 
-static errno_t
+static int
 mfs_read(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *rbytes)
 {
-	errno_t rc;
+	int rc;
 	fs_node_t *fn = NULL;
 
@@ -927,15 +926,15 @@
 out_error:
 	;
-	errno_t tmp = mfs_node_put(fn);
+	int tmp = mfs_node_put(fn);
 	async_answer_0(callid, tmp != EOK ? tmp : rc);
 	return tmp != EOK ? tmp : rc;
 }
 
-static errno_t
+static int
 mfs_write(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *wbytes, aoff64_t *nsize)
 {
 	fs_node_t *fn;
-	errno_t r;
+	int r;
 	int flags = BLOCK_FLAGS_NONE;
 
@@ -1016,9 +1015,9 @@
 }
 
-static errno_t
+static int
 mfs_destroy(service_id_t service_id, fs_index_t index)
 {
 	fs_node_t *fn = NULL;
-	errno_t r;
+	int r;
 
 	r = mfs_node_get(&fn, service_id, index);
@@ -1032,10 +1031,10 @@
 }
 
-static errno_t
+static int
 mfs_destroy_node(fs_node_t *fn)
 {
 	struct mfs_node *mnode = fn->data;
 	bool has_children;
-	errno_t r;
+	int r;
 
 	mfsdebug("mfs_destroy_node %d\n", mnode->ino_i->index);
@@ -1060,9 +1059,9 @@
 }
 
-static errno_t
+static int
 mfs_truncate(service_id_t service_id, fs_index_t index, aoff64_t size)
 {
 	fs_node_t *fn;
-	errno_t r;
+	int r;
 
 	r = mfs_node_get(&fn, service_id, index);
@@ -1084,9 +1083,9 @@
 }
 
-static errno_t
+static int
 mfs_instance_get(service_id_t service_id, struct mfs_instance **instance)
 {
 	void *data;
-	errno_t rc;
+	int rc;
 
 	rc = fs_instance_get(service_id, &data);
@@ -1136,5 +1135,5 @@
  * @return EOK on success, ENOTSUP otherwise.
  */
-static errno_t
+static int
 mfs_check_sanity(struct mfs_sb_info *sbi)
 {
@@ -1153,5 +1152,5 @@
 }
 
-static errno_t
+static int
 mfs_close(service_id_t service_id, fs_index_t index)
 {
@@ -1159,9 +1158,9 @@
 }
 
-static errno_t
+static int
 mfs_sync(service_id_t service_id, fs_index_t index)
 {
 	fs_node_t *fn = NULL;
-	errno_t rc = mfs_node_get(&fn, service_id, index);
+	int rc = mfs_node_get(&fn, service_id, index);
 	if (rc != EOK)
 		return rc;
@@ -1190,9 +1189,9 @@
 }
 
-static errno_t
+static int
 mfs_size_block(service_id_t service_id, uint32_t *size)
 {
 	struct mfs_instance *inst;
-	errno_t rc;
+	int rc;
 
 	rc = mfs_instance_get(service_id, &inst);
@@ -1208,9 +1207,9 @@
 }
 
-static errno_t
+static int
 mfs_total_block_count(service_id_t service_id, uint64_t *count)
 {
 	struct mfs_instance *inst;
-	errno_t rc;
+	int rc;
 	
 	rc = mfs_instance_get(service_id, &inst);
@@ -1226,5 +1225,5 @@
 }
 
-static errno_t
+static int
 mfs_free_block_count(service_id_t service_id, uint64_t *count)
 {
@@ -1232,5 +1231,5 @@
 	
 	struct mfs_instance *inst;
-	errno_t rc = mfs_instance_get(service_id, &inst);
+	int rc = mfs_instance_get(service_id, &inst);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/mfs/mfs_rw.c
===================================================================
--- uspace/srv/fs/mfs/mfs_rw.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/mfs/mfs_rw.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,18 +34,18 @@
 #include "mfs.h"
 
-static errno_t
+static int
 rw_map_ondisk(uint32_t *b, const struct mfs_node *mnode, int rblock,
     bool write_mode, uint32_t w_block);
 
-static errno_t
+static int
 reset_zone_content(struct mfs_instance *inst, uint32_t zone);
 
-static errno_t
+static int
 alloc_zone_and_clear(struct mfs_instance *inst, uint32_t *zone);
 
-static errno_t
+static int
 read_ind_zone(struct mfs_instance *inst, uint32_t zone, uint32_t **ind_zone);
 
-static errno_t
+static int
 write_ind_zone(struct mfs_instance *inst, uint32_t zone, uint32_t *ind_zone);
 
@@ -59,10 +59,10 @@
  * @param pos	Position in file.
  *
- * @return	EOK on success or an error code.
+ * @return	EOK on success or a negative error code.
  */
-errno_t
+int
 mfs_read_map(uint32_t *b, const struct mfs_node *mnode, uint32_t pos)
 {
-	errno_t r;
+	int r;
 	const struct mfs_sb_info *sbi = mnode->instance->sbi;
 	const int block_size = sbi->block_size;
@@ -83,5 +83,5 @@
 }
 
-errno_t
+int
 mfs_write_map(struct mfs_node *mnode, const uint32_t pos, uint32_t new_zone,
     uint32_t *old_zone)
@@ -100,5 +100,5 @@
 }
 
-static errno_t
+static int
 rw_map_ondisk(uint32_t *b, const struct mfs_node *mnode, int rblock,
     bool write_mode, uint32_t w_block)
@@ -107,5 +107,5 @@
 	int ptrs_per_block;
 	uint32_t *ind_zone = NULL, *ind2_zone = NULL;
-	errno_t r = EOK;
+	int r = EOK;
 
 	struct mfs_ino_info *ino_i = mnode->ino_i;
@@ -236,7 +236,7 @@
  * @param new_size	The new size of the inode.
  *
- * @return		EOK on success or an error code.
+ * @return		EOK on success or a negative error code.
  */
-errno_t
+int
 mfs_prune_ind_zones(struct mfs_node *mnode, size_t new_size)
 {
@@ -244,6 +244,5 @@
 	struct mfs_sb_info *sbi = inst->sbi;
 	struct mfs_ino_info *ino_i = mnode->ino_i;
-	int nr_direct, ptrs_per_block, rblock;
-	errno_t r;
+	int nr_direct, ptrs_per_block, rblock, r;
 	int i;
 
@@ -312,9 +311,9 @@
 }
 
-static errno_t
+static int
 reset_zone_content(struct mfs_instance *inst, uint32_t zone)
 {
 	block_t *b;
-	errno_t r;
+	int r;
 
 	r = block_get(&b, inst->service_id, zone, BLOCK_FLAGS_NOREAD);
@@ -328,8 +327,8 @@
 }
 
-static errno_t
+static int
 alloc_zone_and_clear(struct mfs_instance *inst, uint32_t *zone)
 {
-	errno_t r;
+	int r;
 
 	r = mfs_alloc_zone(inst, zone);
@@ -341,9 +340,9 @@
 }
 
-static errno_t
+static int
 read_ind_zone(struct mfs_instance *inst, uint32_t zone, uint32_t **ind_zone)
 {
 	struct mfs_sb_info *sbi = inst->sbi;
-	errno_t r;
+	int r;
 	unsigned i;
 	block_t *b;
@@ -376,9 +375,9 @@
 }
 
-static errno_t
+static int
 write_ind_zone(struct mfs_instance *inst, uint32_t zone, uint32_t *ind_zone)
 {
 	struct mfs_sb_info *sbi = inst->sbi;
-	errno_t r;
+	int r;
 	unsigned i;
 	block_t *b;
Index: uspace/srv/fs/tmpfs/tmpfs.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/tmpfs/tmpfs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,9 +46,7 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <stdio.h>
 #include <task.h>
 #include <libfs.h>
-#include <str.h>
 #include "../../vfs/vfs.h"
 
@@ -88,8 +86,8 @@
 	}
 	
-	errno_t rc = fs_register(vfs_sess, &tmpfs_vfs_info, &tmpfs_ops,
+	int rc = fs_register(vfs_sess, &tmpfs_vfs_info, &tmpfs_ops,
 	    &tmpfs_libfs_ops);
 	if (rc != EOK) {
-		printf(NAME ": Failed to register file system: %s\n", str_error(rc));
+		printf(NAME ": Failed to register file system (%d)\n", rc);
 		return rc;
 	}
Index: uspace/srv/fs/tmpfs/tmpfs_dump.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs_dump.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/tmpfs/tmpfs_dump.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -63,5 +63,5 @@
 	struct rdentry entry;
 	libfs_ops_t *ops = &tmpfs_libfs_ops;
-	errno_t rc;
+	int rc;
 	
 	do {
@@ -168,5 +168,5 @@
 	libfs_ops_t *ops = &tmpfs_libfs_ops;
 	fs_node_t *fn;
-	errno_t rc;
+	int rc;
 
 	rc = block_init(dsid, TMPFS_COMM_SIZE);
